//
// Programa que resetea TODOS los flags definidos en las bases de mensajes
//
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mesa.h"

#define FICHERO "messages.pb"		// Fichero a procesar
#define FICHERO2 "messages.pb2"		// Copia de proceso
#define FICHERO3 "messages.bak"		// Copia seguridad

FILE *lee, *graba;		// I/O Ficheros

areamensa area, *areas;		// Punteros area datos mensajes
int long sek;			// Longitud Fichero
int long narea;			// Numero area en proceso
char pb[255]="";		// Entorno ProBoard

char leebuffer[255]="";		// Buffers path
char grababuffer[255]="";
char bakbuffer[255]="";

int x,y;			// Posicion cursor pantalla

//
// Funciones control Generales
//
void MiError(int);
void ControlBash (char *a);
void VerNumeroArea(int long, int, int );
void VerPresentacion();


void main()
{

	if ((strcat(pb,getenv("PB")))== NULL)	// Control Variable Entorno
	MiError(1);

	ControlBash (pb);		// Control Ultimo caracter 'Slash'

	strcpy(leebuffer,pb);		// Definicion PATH's ficheros
	strcat(leebuffer,FICHERO);
	strcpy(grababuffer,pb);
	strcat(grababuffer,FICHERO2);
	strcpy(bakbuffer,pb);
	strcat(bakbuffer,FICHERO3);


area=*areas;				// Acceso al area de datos


if((lee=fopen(leebuffer,"rb"))==NULL)		// Abre lectura
	MiError(2);

if((graba=fopen(grababuffer,"wb"))==NULL)	// Abre escritura
	MiError(3);

// Bucle a fin de fichero

	fseek(lee,0L,SEEK_END);		// Posiciona FINAL fichero
	sek=ftell(lee);			// Para control final fichero
	fseek(lee,0L,SEEK_SET);		// INICIO

	VerPresentacion();
	printf("\n\n\n\n   Area n -->  ");
	x=wherex();
	y=wherey();

	while (sek>ftell(lee))
	{

    fread(&area,sizeof(areamensa),1,lee);	// Lee area

    area.readFlags=0L;			// Reset FLAGS lectura/escritura
    area.readFlagsNot=0L;
    area.writeFlags=0L;
    area.writeFlagsNot=0L;
    area.sysopFlags=0L;
    area.sysopFlagsNot=0L;

    fwrite(&area,sizeof(areamensa),1,graba);	// Graba fichero salida

    VerNumeroArea(narea++,x,y);			// Visualiza area

    }

    fclose(lee);
    fclose(graba);

    remove(bakbuffer);		// Borra copia vieja
    rename(leebuffer,bakbuffer);	// Renombra copia trabajo
    rename(grababuffer,leebuffer);	// Renombra fichero procesado

    printf("\n\n\n");

	}


void VerNumeroArea(int long i,int x, int y)
{
	gotoxy(x,y);
	printf("%04d",i);
}

void MiError(int i)
{
char *data="No encuentro el fichero --> ";

VerPresentacion();
printf("\n\n\n\n\n\n      ");

	if(i==3)
		printf("%s%s",data,strcat(pb,FICHERO2));

	if(i==2)
		printf("%s%s",data,strcat(pb,FICHERO));

	if(i==1){
		printf("No se encuentra la variable de entorno 'PB'");
		printf("\n\n      Definala con 'SET PB= '");
		}

printf("\n\n\n\n");

exit(i);
}

void ControlBash (char *a)	// Controla ultimo caracter 'SLASH'
{
int i;


i=strlen(a);
if (a[i-1] !='\\')
	strcat(a,"\\");

}

void VerPresentacion()
{
	clrscr();			// Borra Pantalla
	printf("\n\n   ResetFlagMensajes  (c) %s - %s",__DATE__,__TIME__);
	printf("\n\n   Julio Garcia  2:344/18");
	printf("\n\n   jgibm@pobox.com");
}