
/* Estructuras Genericas            */

typedef unsigned short word;
typedef unsigned long  dword;
typedef unsigned char  byte;
typedef unsigned long  accessflags;
typedef unsigned char  combinedboards[125];
typedef unsigned char  bool;
typedef unsigned char  Time[3];
typedef unsigned char  Date[3];
typedef unsigned char  TimeFrame[7][6];

/*
 MESSAGES.PB
*/

typedef struct
   {
  word        areaNum;          /* # of message area (1-10000)                  */
  word        hudsonBase;       /* Number of Hudson message base                */
  char        name[81];         /* Name of message area                         */
  byte        msgType;          /* Kind of message area (Net/Echo/Local)        */
  byte        msgKind;          /* Type of message (Private only/Public only/.) */
  byte        msgBaseType;      /* Type of message base                         */
  char        path[81];         /* Path to Squish or *.MSG                      */
  byte        flags;            /* Alias allowed/forced/prohibited              */
  word        readLevel;        /* Minimum level needed to read msgs            */
  accessflags readFlags;        /* flags needed to read msgs                    */
  accessflags readFlagsNot;     /* flags non-grata to read msgs                 */
  word        writeLevel;       /* Minimum level needed to write msgs           */
  accessflags writeFlags;       /* flags needed to write msgs                   */
  accessflags writeFlagsNot;    /* flags non-grata to read msgs                 */
  word        sysopLevel;       /* Minimum level needed to change msgs          */
  accessflags sysopFlags;       /* flags needed to change msgs                  */
  accessflags sysopFlagsNot;    /* flags non-grata to read msgs                 */

  char        origin[62];       /* Origin line                                  */
  short       aka;              /* AKA                                          */

  word        rcvKillDays;      /* Kill received after xx days                  */
  word        msgKillDays;      /* Kill after xx days                           */
  word        maxMsgs;          /* Max # msgs                                   */

  char        sysop[36];        /* Area Sysop                                   */
  short       replyBoard;       /* Area number where replies should go          */

  char        echoTag[61];      /* Echomail Tag Name                            */
  char        qwkTag[13];       /* QWK Area Name                                */

  byte        groups[4];        /* Groups belonging to                          */
  bool        allGroups;        /* Belongs to all groups                        */
  byte        minAge;           /* Minimum age for this area                    */

  byte        extra[112];
  }areamensa;


#define MSGTYPE_BOTH     0 /* Private/Public */
#define MSGTYPE_PVT      1 /* Private Only   */
#define MSGTYPE_PUBLIC   2 /* Public Only    */
#define MSGTYPE_TOALL    3 /* To All         */

#define MSGKIND_LOCAL    0 /* Local          */
#define MSGKIND_NET      1 /* NetMail        */
#define MSGKIND_ECHO     2 /* EchoMail       */
#define MSGKIND_PVTECHO  3 /* Pvt EchoMail   */

#define MSGBASE_HUDSON   0
#define MSGBASE_SQUISH   1
#define MSGBASE_SDM      2
#define MSGBASE_JAM      3

